Index: trunk/source/processes/hadronic/models/management/src/G4InelasticInteraction.cc
===================================================================
--- trunk/source/processes/hadronic/models/management/src/G4InelasticInteraction.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/management/src/G4InelasticInteraction.cc	(revision 1055)
@@ -24,26 +24,35 @@
 // ********************************************************************
 //
+// $Id: G4InelasticInteraction.cc,v 1.12 2009/01/24 11:56:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
-//
- // Hadronic Process: Inelastic Interaction 
- // original by H.P. Wellisch
- // modified by J.L. Chuma, TRIUMF, 22-Nov-1996
- // Last modified: 27-Mar-1997
- // J.P. Wellisch: 23-Apr-97: throw G4HadronicException(__FILE__, __LINE__,  removed
- // J.P. Wellisch: 24-Apr-97: correction for SetUpPions
- // Modified by J.L. Chuma, 30-Apr-97: added originalTarget to CalculateMomenta
- //                                    since TwoBody needed to reset the target particle
- // J.L. Chuma, 20-Jun-97: Modified CalculateMomenta to correct the decision process
- //                        for whether to use GenerateXandPt or TwoCluster
- // J.L. Chuma, 06-Aug-97: added original incident particle, before Fermi motion and
- //                        evaporation effects are included, needed for calculating
- //                        self absorption and corrections for single particle spectra
- // HPW removed misunderstanding of LocalEnergyDeposit, 11.04.98.
+// Hadronic Process: Inelastic Interaction 
+// original by H.P. Wellisch
+// modified by J.L. Chuma, TRIUMF, 22-Nov-1996
+// Last modified: 27-Mar-1997
+// J.P. Wellisch: 23-Apr-97: throw G4HadronicException(__FILE__, __LINE__,  removed
+// J.P. Wellisch: 24-Apr-97: correction for SetUpPions
+// Modified by J.L. Chuma, 30-Apr-97: added originalTarget to CalculateMomenta
+//                                    since TwoBody needed to reset the target particle
+// J.L. Chuma, 20-Jun-97: Modified CalculateMomenta to correct the decision process
+//                        for whether to use GenerateXandPt or TwoCluster
+// J.L. Chuma, 06-Aug-97: added original incident particle, before Fermi motion and
+//                        evaporation effects are included, needed for calculating
+//                        self absorption and corrections for single particle spectra
+// HPW removed misunderstanding of LocalEnergyDeposit, 11.04.98.
+// 23-Jan-2009 V.Ivanchenko move constructor and destructor to the body
  
 #include "G4InelasticInteraction.hh"
 #include "Randomize.hh"
 #include "G4HadReentrentException.hh"
- 
- G4double
+
+G4InelasticInteraction::G4InelasticInteraction(const G4String& modelName) 
+  : G4HadronicInteraction(modelName)
+{ cache = 0.0;}
+    
+G4InelasticInteraction::~G4InelasticInteraction()
+{}
+ 
+G4double
   G4InelasticInteraction::Pmltpc(      // used in Cascade functions
    G4int np, G4int nm, G4int nz, G4int n, G4double b, G4double c )
@@ -63,5 +72,5 @@
   }
 
- G4bool
+G4bool
   G4InelasticInteraction::MarkLeadingStrangeParticle(
    const G4ReactionProduct &currentParticle,
@@ -92,5 +101,5 @@
   }
  
- void
+void
   G4InelasticInteraction::SetUpPions(
    const G4int np,
@@ -126,5 +135,5 @@
   }
  
- void
+void
   G4InelasticInteraction::GetNormalizationConstant(
    const G4double energy,  // MeV,  <0 means annihilation channels
@@ -170,5 +179,5 @@
   }
  
- void
+void
   G4InelasticInteraction::CalculateMomenta(
    G4FastVector<G4ReactionProduct,GHADLISTSIZE> &vec,
@@ -344,5 +353,5 @@
 
  
- void G4InelasticInteraction::
+void G4InelasticInteraction::
  Rotate(G4FastVector<G4ReactionProduct,GHADLISTSIZE> &vec, G4int &vecLen)
  {
@@ -358,5 +367,5 @@
  }      
 
- void
+void
   G4InelasticInteraction::SetUpChange(
    G4FastVector<G4ReactionProduct,GHADLISTSIZE> &vec,
Index: trunk/source/processes/hadronic/models/neutron_hp/History
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/neutron_hp/History	(revision 1055)
@@ -14,4 +14,9 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+14 May 2009  Tatsumi Koi  (hadr-hpn-V09-02-00)
+- Fix bug in IC electron emissions: Contribution from Chao Zhang (Chao.Zhang@usd.edu) and Dongming Mei(Dongming.Mei@usd.edu)
+	G4NeutronHPPhotonDist.cc
+	G4NeutronHPInelasticCompFS.cc
 
 3 December 2008  Tatsumi Koi  (hadr-hpn-V09-01-28)
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPInelasticCompFS.cc	(revision 1055)
@@ -36,4 +36,6 @@
 //        introduce theNDLDataA,Z which has A and Z of NDL data by T. Koi
 // 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
+// 090514 Fix bug in IC electron emission case 
+//        Contribution from Chao Zhang (Chao.Zhang@usd.edu) and Dongming Mei(Dongming.Mei@usd.edu)
 //
 #include "G4NeutronHPInelasticCompFS.hh"
@@ -69,4 +71,5 @@
 void G4NeutronHPInelasticCompFS::Init (G4double A, G4double Z, G4String & dirName, G4String & aFSType)
 {
+
   gammaPath = "/Inelastic/Gammas/";
     if(!getenv("G4NEUTRONHPDATA")) 
@@ -460,5 +463,5 @@
 
       aHadron.SetMomentum( Vector*p ); 
-                                      
+
     }
 
@@ -577,5 +580,8 @@
       {
         theSec = new G4DynamicParticle;    
-        theSec->SetDefinition(G4Gamma::Gamma());
+        //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
+        //theSec->SetDefinition(G4Gamma::Gamma());
+        theSec->SetDefinition( thePhotons->operator[](i)->GetDefinition() );
+        //But never cause real effect at least with G4NDL3.13 TK
         theSec->SetMomentum(thePhotons->operator[](i)->GetMomentum());
         theResult.AddSecondary(theSec); 
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPPhotonDist.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPPhotonDist.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPPhotonDist.cc	(revision 1055)
@@ -36,4 +36,7 @@
 // 080801 Correcting data disorder which happened when both InitPartial 
 //        and InitAnglurar methods was called in a same instance by T. Koi
+// 090514 Fix bug in IC electron emission case 
+//        Contribution from Chao Zhang (Chao.Zhang@usd.edu) and Dongming Mei(Dongming.Mei@usd.edu)
+//        But it looks like never cause real effect in G4NDL3.13 (at least Natural elements) TK
 //
 // there is a lot of unused (and undebugged) code in this file. Kept for the moment just in case. @@
@@ -48,7 +51,9 @@
 G4bool G4NeutronHPPhotonDist::InitMean(std::ifstream & aDataFile)
 {
+
   G4bool result = true;
   if(aDataFile >> repFlag)
   {
+
     aDataFile >> targetMass;
     if(repFlag==1)
@@ -73,4 +78,5 @@
        theBaseEnergy*=eV;
        aDataFile >> theInternalConversionFlag;
+       // theInternalConversionFlag == 1 No IC, theInternalConversionFlag == 2 with IC 
        aDataFile >> nGammaEnergies;
        theLevelEnergies = new G4double[nGammaEnergies];
@@ -118,4 +124,5 @@
   if (isoFlag != 1)
   {
+if ( repFlag == 2 ) G4cout << "TKDB repFlag == 2 && isoFlag !=1  " << G4endl;
     aDataFile >> tabulationType >> nDiscrete2 >> nIso;
 //080731
@@ -547,7 +554,10 @@
     {
       theOne->SetDefinition(G4Electron::Electron());
+      //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
+      //But never enter at least with G4NDL3.13
+      totalEnergy += G4Electron::Electron()->GetPDGMass(); //proposed correction: add this line for electron
     }
     theOne->SetTotalEnergy(totalEnergy);
-    if( isoFlag == 1)
+    if( isoFlag == 1 )
     {
       G4double costheta = 2.*G4UniformRand()-1;
@@ -555,5 +565,8 @@
       G4double phi = twopi*G4UniformRand();
       G4double sinth = std::sin(theta);
-      G4double en = theOne->GetTotalEnergy();
+      //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
+      //G4double en = theOne->GetTotalEnergy();
+      G4double en = theOne->GetTotalMomentum();
+      //But never cause real effect at least with G4NDL3.13 TK
       G4ThreeVector temp(en*sinth*std::cos(phi), en*sinth*std::sin(phi), en*std::cos(theta) );
       theOne->SetMomentum( temp ) ;
@@ -569,9 +582,15 @@
       if(ii<nIso)
       {
+        //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
         // isotropic distribution
-        G4double theta = pi*G4UniformRand();
+        //G4double theta = pi*G4UniformRand();
+        G4double theta = std::acos(2.*G4UniformRand()-1.);
+        //But this is alos never cause real effect at least with G4NDL3.13 TK  not repFlag == 2 AND isoFlag != 1
         G4double phi = twopi*G4UniformRand();
         G4double sinth = std::sin(theta);
-        G4double en = theOne->GetTotalEnergy();
+        //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
+        //G4double en = theOne->GetTotalEnergy();
+        G4double en = theOne->GetTotalMomentum();
+        //But never cause real effect at least with G4NDL3.13 TK
         G4ThreeVector tempVector(en*sinth*std::cos(phi), en*sinth*std::sin(phi), en*std::cos(theta) );
         theOne->SetMomentum( tempVector ) ;
@@ -594,5 +613,8 @@
         G4double phi = twopi*G4UniformRand();
         G4double sinth = std::sin(theta);
-        G4double en = theOne->GetTotalEnergy();
+        //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
+        //G4double en = theOne->GetTotalEnergy();
+        G4double en = theOne->GetTotalMomentum();
+        //But never cause real effect at least with G4NDL3.13 TK
         G4ThreeVector tempVector(en*sinth*std::cos(phi), en*sinth*std::sin(phi), en*std::cos(theta) );
         theOne->SetMomentum( tempVector ) ;
@@ -612,5 +634,8 @@
         G4double phi = twopi*G4UniformRand();
         G4double sinth = std::sin(theta);
-        G4double en = theOne->GetTotalEnergy();
+        //Bug reported Chao Zhang (Chao.Zhang@usd.edu), Dongming Mei(Dongming.Mei@usd.edu) Feb. 25, 2009 
+        //G4double en = theOne->GetTotalEnergy();
+        G4double en = theOne->GetTotalMomentum();
+        //But never cause real effect at least with G4NDL3.13 TK
         G4ThreeVector tmpVector(en*sinth*std::cos(phi), en*sinth*std::sin(phi), en*costh );
         theOne->SetMomentum( tmpVector ) ;
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/History	(revision 1055)
@@ -1,3 +1,3 @@
-$Id: History,v 1.5 2007/05/03 22:10:54 gunter Exp $
+$Id: History,v 1.7 2009/05/22 16:36:52 gunter Exp $
 -------------------------------------------------------------------
 
@@ -16,4 +16,18 @@
      ---------------------------------------------------------------
 
+22-May-2009   Gunter Folger             (had-hadronization-V09-02-01)
+- remove temporary workaround - fix is now in QGS
+- change pt sampling in G4LundStringFragmentation to avoid near endless
+  loop; this should improve overall performance slightly.
+  Affected G4VLongitudinalStringDecay, where SampleQuarkPt() is 
+  implemented; affected .hh and .cc for new optional argument of max Pt 
+  to SampleQuarkPt()
+
+18-May-2009   Gunter Folger             (had-hadronization-V09-02-00)
+---------------------------------------------------------------------
+- reset formatting changes by MK with tags hadr-prtn-hadr-V09-02-xx
+- temporary workaround for wrong PDG codes created on wrong input from QGS 
+   when used for e.g. antiproton.
+   
 2-May 2007    Gunter Folger             (had-hadronization-V08-02-03)
 ---------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4HadronBuilder.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4HadronBuilder.hh,v 1.3 2006/06/29 20:54:46 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4HadronBuilder.hh,v 1.5 2009/05/18 09:43:40 gunter Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/include/G4VLongitudinalStringDecay.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VLongitudinalStringDecay.hh,v 1.6 2008/06/23 08:35:54 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4VLongitudinalStringDecay.hh,v 1.7 2009/05/22 16:35:47 gunter Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 // Maxim Komogorov
 //
@@ -116,5 +116,5 @@
 //   used by G4VKinkyStringDecy..
    G4int SampleQuarkFlavor(void);
-   G4ThreeVector SampleQuarkPt();
+   G4ThreeVector SampleQuarkPt(G4double ptMax=-1.); // -1. no limit on maxpt.
 
 protected:
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4ExcitedStringDecay.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4ExcitedStringDecay.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4ExcitedStringDecay.cc	(revision 1055)
@@ -134,5 +134,5 @@
       }
     }
-    
+#ifdef debug_G4ExcitedStringDecay     
     if(!success)
     {
@@ -144,5 +144,5 @@
 //       throw G4HadronicException(__FILE__, __LINE__, "G4ExcitedStringDecay failed to correct...");
     }
-
+#endif     
     // Compute c.m.s. interaction velocity and KTV back boost   
     Beta = TotalCollisionMom.boostVector();
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4HadronBuilder.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4HadronBuilder.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4HadronBuilder.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4HadronBuilder.cc,v 1.7 2008/04/25 14:20:14 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4HadronBuilder.cc,v 1.10 2009/05/22 16:34:31 gunter Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -----------------------------------------------------------------------------
@@ -147,5 +147,5 @@
 	   if( (IsUp && IsAnti ) || (!IsUp && !IsAnti ) ) 
 	      PDGEncoding = - PDGEncoding;
-	}
+ 	}
 	   
 	   
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4LundStringFragmentation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4LundStringFragmentation.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4LundStringFragmentation.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4LundStringFragmentation.cc,v 1.13 2008/06/23 09:17:10 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02 $ 1.8
+// $Id: G4LundStringFragmentation.cc,v 1.14 2009/05/22 16:36:46 gunter Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $ 1.8
 //
 // -----------------------------------------------------------------------------
@@ -508,6 +508,20 @@
    {
       do                                                                      
-      {                                                                     
-         Pt=SampleQuarkPt(); Pt.setZ(0); G4double Pt2=Pt.mag2();              
+      {  
+         // GF 22-May-09, limit sampled pt to allowed range
+         
+	 G4double termD = InitialMass*InitialMass -Mass*Mass - AntiMass*AntiMass;
+	 G4double termab = 4*sqr(Mass*AntiMass);
+	 G4double termN = 2*termD + 4*Mass*Mass + 4*AntiMass*AntiMass;
+	 G4double pt2max=(termD*termD - termab )/ termN ;
+	 
+//	 G4cout << " termD, ab, N " << termD << "  " << termab << "  " << termN 
+//	        <<  "   pt2max= " << pt2max ;
+	 	                                                                          
+         Pt=SampleQuarkPt(sqrt(pt2max)); Pt.setZ(0); G4double Pt2=Pt.mag2();
+
+	 
+//	 G4cout << " sampled Pt2 = " << Pt2 << "  " << pt2max-Pt2 << G4endl;              
+         // end.. GF
 
 //G4cout<<"Sample4Momentum Pt x y "<<Pt.getX()<<" "<<Pt.getY()<<G4endl;
@@ -521,5 +535,5 @@
                          4.*MassMt2*AntiMassMt2;                                
       }                                                                     
-      while(AvailablePz2 < 0.);                                               
+      while(AvailablePz2 < 0.);     // GF will occur only for numerical precision problem with limit in sampled pt                                               
                                                                             
       AvailablePz2 /=(4.*InitialMass*InitialMass);                            
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4VLongitudinalStringDecay.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4VLongitudinalStringDecay.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4VLongitudinalStringDecay.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VLongitudinalStringDecay.cc,v 1.13 2008/06/23 08:35:55 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4VLongitudinalStringDecay.cc,v 1.14 2009/05/22 16:35:47 gunter Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -----------------------------------------------------------------------------
@@ -485,7 +485,14 @@
 //    }
 
-G4ThreeVector G4VLongitudinalStringDecay::SampleQuarkPt()
+G4ThreeVector G4VLongitudinalStringDecay::SampleQuarkPt(G4double ptMax)
    {
-   G4double Pt = -std::log(G4UniformRand());
+   G4double Pt;
+   if ( ptMax < 0 ) {
+      // sample full gaussian
+      Pt = -std::log(G4UniformRand());
+   } else {
+      // sample in limited range
+      Pt = -std::log(CLHEP::RandFlat::shoot(exp(-sqr(ptMax)/sqr(SigmaQT)), 1.));
+   }
    Pt = SigmaQT * std::sqrt(Pt);
    G4double phi = 2.*pi*G4UniformRand();
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/History	(revision 1055)
@@ -1,3 +1,3 @@
-$Id: History,v 1.6 2008/09/19 09:54:23 gunter Exp $
+$Id: History,v 1.8 2009/05/19 12:48:42 gunter Exp $
 -------------------------------------------------------------------
 
@@ -16,4 +16,19 @@
      ---------------------------------------------------------------
 
+19 May 2009, G.Folger		(hadr-qgsm-V09-02-02)
+-----------------------------------------------------
+- fix in G4SPBaryon: for antibaryon, a  diquark & quark was given instead of 
+      anti-diquark & antiquark; note the reverse order, too. 
+    Fixes problems with incident anti baryons, e.g. antiproton, manifesting
+    in problems with forming hadrons.
+
+29 Apr 2009 m. Kosov       (hadr-qgsm-V09-02-01)
+------------------------------------------------
+Very important bug fix in G4QGSParticipants.cc to let QGSC working from E=0
+Added by GF (19-May-09):
+- this very important "bug" fix modifies G4G4QGSParticipants.cc and
+   G4GammaParticipants.cc:
+     changing the value of Threshold from 0.45 GeV to 0.GeV, 
+     and disables an Exception if s < sqr(total mass + Threshold)
 
 15 Sep 2008 G.Folger       (hadr-qgsm-V09-01-01)
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/include/G4QGSParticipants.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/include/G4QGSParticipants.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/include/G4QGSParticipants.hh	(revision 1055)
@@ -83,6 +83,6 @@
     enum  { SOFT, DIFFRACTIVE };
     const G4int nCutMax; 
-    const G4double ThersholdParameter; 
-    const G4double QGSMThershold; 
+    const G4double ThresholdParameter; 
+    const G4double QGSMThreshold; 
     const G4double theNucleonRadius;
     
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4GammaParticipants.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4GammaParticipants.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4GammaParticipants.cc	(revision 1055)
@@ -50,9 +50,10 @@
   G4double ThresholdMass = thePrimary.GetMass() + theTargetNuc[0]->GetDefinition()->GetPDGMass(); 
   ModelMode = SOFT;
-  if (sqr(ThresholdMass + ThersholdParameter) > s)
+  if (sqr(ThresholdMass + ThresholdParameter) > s)
   {
-    throw G4HadronicException(__FILE__, __LINE__, "Initial energy is too low. The 4-vectors of the input are inconsistant with the particle masses.");
+    ModelMode = DIFFRACTIVE;
+    //throw G4HadronicException(__FILE__, __LINE__, "Initial energy is too low. The 4-vectors of the input are inconsistant with the particle masses.");
   }
-  if (sqr(ThresholdMass + QGSMThershold) > s) // thus only diffractive in cascade!
+  if (sqr(ThresholdMass + QGSMThreshold) > s) // thus only diffractive in cascade!
   {
     ModelMode = DIFFRACTIVE;
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4QGSParticipants.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4QGSParticipants.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4QGSParticipants.cc	(revision 1055)
@@ -36,6 +36,7 @@
 
 G4QGSParticipants::G4QGSParticipants() : theDiffExcitaton(), //0.7*GeV, 250*MeV, 250*MeV),
-                                         nCutMax(7),ThersholdParameter(0.45*GeV),
-                                         QGSMThershold(3*GeV),theNucleonRadius(1.5*fermi)
+                                         //nCutMax(7),ThresholdParameter(0.45*GeV),
+                                         nCutMax(7),ThresholdParameter(0.000*GeV),
+                                         QGSMThreshold(3*GeV),theNucleonRadius(1.5*fermi)
                                          
 {
@@ -43,6 +44,6 @@
 
 G4QGSParticipants::G4QGSParticipants(const G4QGSParticipants &right)
-: G4VParticipants(), nCutMax(right.nCutMax),ThersholdParameter(right.ThersholdParameter),
-  QGSMThershold(right.QGSMThershold),theNucleonRadius(right.theNucleonRadius)
+: G4VParticipants(), nCutMax(right.nCutMax),ThresholdParameter(right.ThresholdParameter),
+  QGSMThreshold(right.QGSMThreshold),theNucleonRadius(right.theNucleonRadius)
 {
 }
@@ -91,9 +92,10 @@
   G4double ThresholdMass = thePrimary.GetMass() + pNucleon->GetDefinition()->GetPDGMass(); 
   ModelMode = SOFT;
-  if (sqr(ThresholdMass + ThersholdParameter) > s)
-  {
-    throw G4HadronicException(__FILE__, __LINE__, "Initial energy is too low. The 4-vectors of the input are inconsistant with the particle masses.");
-  }
-  if (sqr(ThresholdMass + QGSMThershold) > s) // thus only diffractive in cascade!
+  if (sqr(ThresholdMass + ThresholdParameter) > s)
+  {
+    ModelMode = DIFFRACTIVE;
+    //throw G4HadronicException(__FILE__, __LINE__, "Initial energy is too low. The 4-vectors of the input are inconsistant with the particle masses.");
+  }
+  if (sqr(ThresholdMass + QGSMThreshold) > s) // thus only diffractive in cascade!
   {
     ModelMode = DIFFRACTIVE;
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4SPBaryon.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4SPBaryon.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4SPBaryon.cc	(revision 1055)
@@ -104,6 +104,6 @@
       if (theDefinition->GetPDGEncoding() < 0)
       {
-	quark = -(*i)->GetDiQuark();
-	diQuark = -(*i)->GetQuark();                   
+	quark = (*i)->GetDiQuark();
+	diQuark = (*i)->GetQuark();                   
       }
       else
Index: trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/History
===================================================================
--- trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/History	(revision 1055)
@@ -1,3 +1,3 @@
-$Id: History,v 1.6 2008/10/02 21:05:09 dennis Exp $
+$Id: History,v 1.8 2009/02/06 08:58:20 vnivanch Exp $
 -------------------------------------------------------------------
 
@@ -16,4 +16,11 @@
      ---------------------------------------------------------------
 
+06 Feb 2009 V.Ivantchenko (hadr-munuclear-V09-02-01)
+----------------------------------------------------
+
+24 Jan 2009 V.Ivantchenko (hadr-munuclear-V09-02-00)
+----------------------------------------------------
+- G4MuNuclearInteraction added deregistration of the process 
+
  4 Oct 2008 Dennis Wright (hadr-munuclear-V09-01-01)
 ----------------------------------------------------
@@ -21,11 +28,11 @@
   12 to fHadronInelastic
 
- 2 Sep 2008 V.Ivantchenko (hadr-munuclear-V09-01-00)
------------------------------------------------------------------------
+ 2 Sep 2008 V.Ivanchenko (hadr-munuclear-V09-01-00)
+---------------------------------------------------
 - G4MuNuclearInteraction added SubType and registration in the 
                          G4HadronicProcessStore; added PreparePhysicsTable
                          method and cleanup for readability 
 
- 4 Nov 2006 Dennis Wright for V. Ivantchenko (hadr-munuclear-V08-01-00)
+ 4 Nov 2006 Dennis Wright for V.Ivanchenko (hadr-munuclear-V08-01-00)
 -----------------------------------------------------------------------
 - G4MuNuclearInteraction::ComputeMicroscopicCrossSection: prevent NaN
Index: trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/include/G4MuNuclearInteraction.icc
===================================================================
--- trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/include/G4MuNuclearInteraction.icc	(revision 1007)
+++ trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/include/G4MuNuclearInteraction.icc	(revision 1055)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MuNuclearInteraction.icc,v 1.3 2006/06/29 20:57:22 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // $Id: 
Index: trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/src/G4MuNuclearInteraction.cc
===================================================================
--- trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/src/G4MuNuclearInteraction.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/photolepton_hadron/muon_nuclear/src/G4MuNuclearInteraction.cc	(revision 1055)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: G4MuNuclearInteraction.cc,v 1.11 2008/10/02 21:04:54 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4MuNuclearInteraction.cc,v 1.12 2009/01/24 11:59:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // $Id: 
@@ -38,6 +37,8 @@
 //      added simple model for hadronic vertex, J.P. Wellisch, November 1998
 // --------------------------------------------------------------
-// 26/10/98: new corr.s from R.Kokoulin + cleanup , L.Urban
+// 26/10/1998: new corr.s from R.Kokoulin + cleanup , L.Urban
+// 23/01/2009  V.Ivanchenko Add deregistration
 //
+
 #include "G4MuNuclearInteraction.hh"
 #include "G4UnitsTable.hh"
@@ -74,4 +75,6 @@
 G4MuNuclearInteraction::~G4MuNuclearInteraction()
 {
+  G4HadronicProcessStore::Instance()->DeRegisterExtraProcess(this);
+
   if (theMeanFreePathTable) {
     theMeanFreePathTable->clearAndDestroy();
Index: trunk/source/processes/hadronic/models/pre_equilibrium/History
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/History	(revision 1055)
@@ -14,4 +14,26 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+13-February 2009 V.Ivanchenko   hadr-pre-V09-02-03
+---------------------------------------------------
+G4PreCompoundXXX - changed the shape of probabilities (return back to 9.2)  
+                   for d, t, He3, alpha (JMQ)
+
+12-February 2009 V.Ivanchenko   hadr-pre-V09-02-02
+---------------------------------------------------
+G4PreCompoundXXX - changed the shape of probabilities 
+                   for d, t, He3, alpha near the Coulomb barrier (JMQ)
+
+11-February 2009 V.Ivanchenko   hadr-pre-V09-02-01
+---------------------------------------------------
+G4PreCompoundXXX - set default Opt3 back, add decrease Coulomb barrier
+                   for d, t, a, he3 (JMQ)
+
+10-February 2009 V.Ivanchenko   hadr-pre-V09-02-00
+---------------------------------------------------
+Some clean up of comments
+G4PreCompoundIon - fixed probability of light ion emmision (JMQ)
+G4PreCompoundXXX - by default Opt1 is used for d, t, a, he3, 
+                   Opt3 for n, p (JMQ)
 
 09-December 2008 A.Howard   hadr-pre-V09-01-15
Index: trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/include/G4PreCompoundEmission.icc
===================================================================
--- trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/include/G4PreCompoundEmission.icc	(revision 1007)
+++ trunk/source/processes/hadronic/models/pre_equilibrium/exciton_model/include/G4PreCompoundEmission.icc	(revision 1055)
@@ -24,4 +24,11 @@
 // ********************************************************************
 //
+// $Id: G4PreCompoundEmission.icc,v 1.5 2009/02/10 16:01:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+//
+// Author:         V.Lara
+//
+// Modified:  
 // Modif (03 September 2008) by J. M. Quesada for external choice of inverse 
 // cross section option
@@ -34,5 +41,4 @@
   return;
 }
-
 
 inline G4double G4PreCompoundEmission::GetTotalProbability(const G4Fragment & aFragment) 
